function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : String(i); }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
import hide from "./hide";

// 显示Toast
// eslint-disable-next-line
function show(props) {
  var _ref = _objectSpread(_objectSpread({}, (this === null || this === void 0 ? void 0 : this.defaultProps) || {}), props || {}),
    duration = _ref.duration,
    maskClickable = _ref.maskClickable,
    position = _ref.position,
    id = _ref.id,
    maskProps = _ref.maskProps,
    className = _ref.className,
    style = _ref.style,
    content = _ref.content,
    onVisibleChange = _ref.onVisibleChange;

  // 渲染
  function render() {
    var toastId = id || '__SeedsUI_toast_el__';
    // 如果没生成成功, 则强制生成
    var mask = document.getElementById(toastId);
    if (!mask) {
      // Create mask
      mask = document.createElement('div');
      mask.innerHTML = "<div class=\"toast\">\n        <div class=\"toast-wrapper\">\n          <div class=\"toast-content\"></div>\n        </div>\n      </div>"
      // 添加到dom上
      ;
      (document.getElementById('root') || document.body).appendChild(mask);
    }

    // Update mask
    mask.setAttribute('class', "mask toast-mask".concat(maskProps !== null && maskProps !== void 0 && maskProps.className ? ' ' + (maskProps === null || maskProps === void 0 ? void 0 : maskProps.className) : '').concat(maskClickable !== false ? ' toast-propagation' : ''));
    mask.setAttribute('id', toastId);
    mask.setAttribute('style', '');
    for (var key in (maskProps === null || maskProps === void 0 ? void 0 : maskProps.style) || {}) {
      mask.style[key] = maskProps === null || maskProps === void 0 ? void 0 : maskProps.style[key];
    }

    // Update container
    var container = mask.querySelector('.toast');
    if (container) {
      container === null || container === void 0 || container.setAttribute('class', "toast ".concat(position || 'middle'));
    }

    // Update wrapper
    var wrapper = mask.querySelector('.toast-wrapper');
    if (wrapper) {
      wrapper === null || wrapper === void 0 || wrapper.setAttribute('class', "toast-wrapper ".concat(className ? ' ' + className : ''));
      wrapper === null || wrapper === void 0 || wrapper.setAttribute('style', '');
      for (var _key in style || {}) {
        wrapper.style[_key] = style[_key];
      }
    }

    // Update content
    var contentDOM = mask.querySelector('.toast-content');
    if (contentDOM) {
      contentDOM.innerHTML = content || '';
    }

    // Open toast
    mask.classList.add('active');
    mask.childNodes[0].classList.add('active');
    if (typeof onVisibleChange === 'function') {
      onVisibleChange(true);
    }

    // 显示数秒后隐藏
    if (mask.showTimeout) window.clearTimeout(mask.showTimeout);
    mask.showTimeout = setTimeout(function () {
      hide({
        onVisibleChange: onVisibleChange
      });
    }, typeof duration === 'number' ? duration : 2000);

    // 返回节点
    return mask;
  }
  return render();
}
export default show;